io.vertx.reactivex.core.http

## Class ServerWebSocket

- java.lang.Object
- - io.vertx.reactivex.core.http.ServerWebSocket

- All Implemented Interfaces:
    WebSocketBase, ReadStream<Buffer>, StreamBase, WriteStream<Buffer>

      public class ServerWebSocket
      extends Object
      implements WebSocketBase

  Represents a server side WebSocket.

  Instances of this class are passed into a `HttpServer.webSocketHandler(io.vertx.core.Handler<io.vertx.reactivex.core.http.ServerWebSocket>)` or provided when a WebSocket handshake is manually `HttpServerRequest.toWebSocket(io.vertx.core.Handler<io.vertx.core.AsyncResult<io.vertx.reactivex.core.http.ServerWebSocket>>)`ed.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static io.vertx.lang.rx.TypeArg<ServerWebSocket>` | `__TYPE_ARG`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ServerWebSocket(Object delegate)`
    `ServerWebSocket(ServerWebSocket delegate)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `accept()` Accept the WebSocket and terminate the WebSocket handshake.
    `String` | `binaryHandlerID()` When a `WebSocket` is created it automatically registers an event handler with the event bus - the ID of that handler is given by this method.
    `WebSocketBase` | `binaryMessageHandler(Handler<Buffer> handler)` Set a binary message handler on the connection.
    `void` | `close()` Same as `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `close(Handler<AsyncResult<Void>> handler)` Same as `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `close(short statusCode)` Same as `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `close(short statusCode, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `void` | `close(short statusCode, String reason)` Same as but with an `handler` called when the operation completes
    `void` | `close(short statusCode, String reason, Handler<AsyncResult<Void>> handler)` Same as but with an `handler` called when the operation completes
    `ServerWebSocket` | `closeHandler(Handler<Void> handler)` Set a close handler.
    `String` | `closeReason()` Returns the close reason message from the remote endpoint or `null` when not yet received.
    `Short` | `closeStatusCode()` Returns the close status code received from the remote endpoint or `null` when not yet received.
    `ServerWebSocket` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `void` | `end()` Calls `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)`
    `void` | `end(Buffer data)` Same as but with an `handler` called when the operation completes
    `void` | `end(Buffer data, Handler<AsyncResult<Void>> handler)` Same as but with an `handler` called when the operation completes
    `void` | `end(Handler<AsyncResult<Void>> handler)` Calls `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)`
    `ServerWebSocket` | `endHandler(Handler<Void> endHandler)` Set an end handler.
    `boolean` | `equals(Object o)`
    `ServerWebSocket` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the read stream.
    `ServerWebSocket` | `fetch(long amount)` Fetch the specified `amount` of elements.
    `ServerWebSocket` | `frameHandler(Handler<WebSocketFrame> handler)` Set a frame handler on the connection.
    `ServerWebSocket` | `getDelegate()`
    `ServerWebSocket` | `handler(Handler<Buffer> handler)` Set a data handler.
    `int` | `hashCode()`
    `MultiMap` | `headers()` Returns the HTTP headers when the WebSocket is first obtained in the handler.
    `String` | `host()`
    `boolean` | `isClosed()`
    `boolean` | `isSsl()`
    `SocketAddress` | `localAddress()`
    `static ServerWebSocket` | `newInstance(ServerWebSocket arg)`
    `String` | `path()`
    `ServerWebSocket` | `pause()` Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.
    `Pipe<Buffer>` | `pipe()` Pause this stream and return a to transfer the elements of this stream to a destination .
    `void` | `pipeTo(WriteStream<Buffer> dst)` Pipe this `ReadStream` to the `WriteStream`.
    `void` | `pipeTo(WriteStream<Buffer> dst, Handler<AsyncResult<Void>> handler)` Pipe this `ReadStream` to the `WriteStream`.
    `WebSocketBase` | `pongHandler(Handler<Buffer> handler)` Set a pong frame handler on the connection.
    `String` | `query()`
    `void` | `reject()` Reject the WebSocket.
    `void` | `reject(int status)` Like `reject()` but with a `status`.
    `SocketAddress` | `remoteAddress()`
    `ServerWebSocket` | `resume()` Resume reading, and sets the buffer in `flowing` mode.
    `Completable` | `rxClose()` Same as `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Completable` | `rxClose(short statusCode)` Same as `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Completable` | `rxClose(short statusCode, String reason)` Same as but with an `handler` called when the operation completes
    `Completable` | `rxEnd()` Calls `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)`
    `Completable` | `rxEnd(Buffer data)` Same as but with an `handler` called when the operation completes
    `Completable` | `rxPipeTo(WriteStream<Buffer> dst)` Pipe this `ReadStream` to the `WriteStream`.
    `Single<Integer>` | `rxSetHandshake(Future<Integer> future)` Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be accepted when the `future` succeeds with the HTTP status code rejected when the `future` is succeeds with an HTTP status code different than rejected when the `future` fails with the HTTP status code `500` The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward.
    `Single<Integer>` | `rxSetHandshake(Single<Integer> future)` Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be accepted when the `future` succeeds with the HTTP status code rejected when the `future` is succeeds with an HTTP status code different than rejected when the `future` fails with the HTTP status code `500` The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward.
    `Completable` | `rxWrite(Buffer data)` Same as but with an `handler` called when the operation completes
    `Completable` | `rxWriteBinaryMessage(Buffer data)` Same as `WebSocketBase.writeBinaryMessage(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Completable` | `rxWriteFinalBinaryFrame(Buffer data)` Same as `WebSocketBase.writeFinalBinaryFrame(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Completable` | `rxWriteFinalTextFrame(String text)` Same as `WebSocketBase.writeFinalTextFrame(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Completable` | `rxWriteFrame(WebSocketFrame frame)` Same as `WebSocketBase.writeFrame(io.vertx.reactivex.core.http.WebSocketFrame, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `Completable` | `rxWritePing(Buffer data)` Writes a ping frame to the connection.
    `Completable` | `rxWritePong(Buffer data)` Writes a pong frame to the connection.
    `Completable` | `rxWriteTextMessage(String text)` Same as `WebSocketBase.writeTextMessage(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `String` | `scheme()`
    `void` | `setHandshake(Future<Integer> future)` Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be accepted when the `future` succeeds with the HTTP status code rejected when the `future` is succeeds with an HTTP status code different than rejected when the `future` fails with the HTTP status code `500` The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward.
    `void` | `setHandshake(Future<Integer> future, Handler<AsyncResult<Integer>> handler)` Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be accepted when the `future` succeeds with the HTTP status code rejected when the `future` is succeeds with an HTTP status code different than rejected when the `future` fails with the HTTP status code `500` The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward.
    `void` | `setHandshake(Single<Integer> future)` Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be accepted when the `future` succeeds with the HTTP status code rejected when the `future` is succeeds with an HTTP status code different than rejected when the `future` fails with the HTTP status code `500` The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward.
    `void` | `setHandshake(Single<Integer> future, Handler<AsyncResult<Integer>> handler)` Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be accepted when the `future` succeeds with the HTTP status code rejected when the `future` is succeeds with an HTTP status code different than rejected when the `future` fails with the HTTP status code `500` The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward.
    `ServerWebSocket` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `SSLSession` | `sslSession()`
    `String` | `subProtocol()` Returns the WebSocket sub protocol selected by the WebSocket handshake.
    `String` | `textHandlerID()` When a `WebSocket` is created it automatically registers an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.
    `WebSocketBase` | `textMessageHandler(Handler<String> handler)` Set a text message handler on the connection.
    `Flowable<Buffer>` | `toFlowable()`
    `Observable<Buffer>` | `toObservable()`
    `WriteStreamObserver<Buffer>` | `toObserver()`
    `String` | `toString()`
    `WriteStreamSubscriber<Buffer>` | `toSubscriber()`
    `String` | `uri()`
    `void` | `write(Buffer data)` Same as but with an `handler` called when the operation completes
    `void` | `write(Buffer data, Handler<AsyncResult<Void>> handler)` Same as but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeBinaryMessage(Buffer data)` Same as `WebSocketBase.writeBinaryMessage(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeBinaryMessage(Buffer data, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeBinaryMessage(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeFinalBinaryFrame(Buffer data)` Same as `WebSocketBase.writeFinalBinaryFrame(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeFinalBinaryFrame(Buffer data, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeFinalBinaryFrame(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeFinalTextFrame(String text)` Same as `WebSocketBase.writeFinalTextFrame(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeFinalTextFrame(String text, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeFinalTextFrame(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeFrame(WebSocketFrame frame)` Same as `WebSocketBase.writeFrame(io.vertx.reactivex.core.http.WebSocketFrame, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeFrame(WebSocketFrame frame, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeFrame(io.vertx.reactivex.core.http.WebSocketFrame, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `WebSocketBase` | `writePing(Buffer data)` Writes a ping frame to the connection.
    `WebSocketBase` | `writePing(Buffer data, Handler<AsyncResult<Void>> handler)` Writes a ping frame to the connection.
    `WebSocketBase` | `writePong(Buffer data)` Writes a pong frame to the connection.
    `WebSocketBase` | `writePong(Buffer data, Handler<AsyncResult<Void>> handler)` Writes a pong frame to the connection.
    `boolean` | `writeQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
    `ServerWebSocket` | `writeTextMessage(String text)` Same as `WebSocketBase.writeTextMessage(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
    `ServerWebSocket` | `writeTextMessage(String text, Handler<AsyncResult<Void>> handler)` Same as `WebSocketBase.writeTextMessage(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface io.vertx.reactivex.core.http.WebSocketBase

      `newInstance`

    - ### Methods inherited from interface io.vertx.reactivex.core.streams.ReadStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.reactivex.core.streams.WriteStream

      `newInstance, newInstance`

    - ### Methods inherited from interface io.vertx.reactivex.core.streams.StreamBase

      `newInstance`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<ServerWebSocket> __TYPE_ARG

  - ### Constructor Detail

    - #### ServerWebSocket

          public ServerWebSocket(ServerWebSocket delegate)

    - #### ServerWebSocket

          public ServerWebSocket(Object delegate)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public ServerWebSocket getDelegate()

      Specified by:
        `getDelegate` in interface `WebSocketBase`
      Specified by:
        `getDelegate` in interface `ReadStream<Buffer>`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<Buffer>`

    - #### toObservable

          public Observable<Buffer> toObservable()

      Specified by:
        `toObservable` in interface `ReadStream<Buffer>`

    - #### toFlowable

          public Flowable<Buffer> toFlowable()

      Specified by:
        `toFlowable` in interface `ReadStream<Buffer>`

    - #### toObserver

          public WriteStreamObserver<Buffer> toObserver()

    - #### toSubscriber

          public WriteStreamSubscriber<Buffer> toSubscriber()

    - #### write

          public void write(Buffer data,
                            Handler<AsyncResult<Void>> handler)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `write` in interface `WebSocketBase`
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -
        `handler` -

    - #### write

          public void write(Buffer data)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `write` in interface `WebSocketBase`
      Specified by:
        `write` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -

    - #### rxWrite

          public Completable rxWrite(Buffer data)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `rxWrite` in interface `WebSocketBase`
      Specified by:
        `rxWrite` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -
      Returns:

    - #### end

          public void end(Buffer data,
                          Handler<AsyncResult<Void>> handler)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -
        `handler` -

    - #### end

          public void end(Buffer data)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -

    - #### rxEnd

          public Completable rxEnd(Buffer data)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `rxEnd` in interface `WebSocketBase`
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Parameters:
        `data` -
      Returns:

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WebSocketBase`
      Specified by:
        `writeQueueFull` in interface `WriteStream<Buffer>`
      Returns:
        `true` if write queue is full

    - #### pipe

          public Pipe<Buffer> pipe()

      Pause this stream and return a to transfer the elements of this stream to a destination .

      The stream will be resumed when the pipe will be wired to a `WriteStream`.
      Specified by:
        `pipe` in interface `WebSocketBase`
      Specified by:
        `pipe` in interface `ReadStream<Buffer>`
      Returns:
        a pipe

    - #### pipeTo

          public void pipeTo(WriteStream<Buffer> dst,
                             Handler<AsyncResult<Void>> handler)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Once this stream has ended or failed, the write stream will be ended and the `handler` will be called with the result.

      Specified by:
        `pipeTo` in interface `WebSocketBase`
      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
        `handler` -

    - #### pipeTo

          public void pipeTo(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Once this stream has ended or failed, the write stream will be ended and the `handler` will be called with the result.

      Specified by:
        `pipeTo` in interface `WebSocketBase`
      Specified by:
        `pipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream

    - #### rxPipeTo

          public Completable rxPipeTo(WriteStream<Buffer> dst)

      Pipe this `ReadStream` to the `WriteStream`.

      Elements emitted by this stream will be written to the write stream until this stream ends or fails.

      Once this stream has ended or failed, the write stream will be ended and the `handler` will be called with the result.

      Specified by:
        `rxPipeTo` in interface `WebSocketBase`
      Specified by:
        `rxPipeTo` in interface `ReadStream<Buffer>`
      Parameters:
        `dst` - the destination write stream
      Returns:

    - #### binaryHandlerID

          public String binaryHandlerID()

      When a `WebSocket` is created it automatically registers an event handler with the event bus - the ID of that handler is given by this method.

      Given this ID, a different event loop can send a binary frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Specified by:
        `binaryHandlerID` in interface `WebSocketBase`
      Returns:
        the binary handler id

    - #### textHandlerID

          public String textHandlerID()

      When a `WebSocket` is created it automatically registers an event handler with the eventbus, the ID of that handler is given by `textHandlerID`.

      Given this ID, a different event loop can send a text frame to that event handler using the event bus and that buffer will be received by this instance in its own event loop and written to the underlying connection. This allows you to write data to other WebSockets which are owned by different event loops.

      Specified by:
        `textHandlerID` in interface `WebSocketBase`
      Returns:

    - #### subProtocol

          public String subProtocol()

      Returns the WebSocket sub protocol selected by the WebSocket handshake.

      On the server, the value will be `null` when the handler receives the WebSocket callback as the handshake will not be completed yet.
      Specified by:
        `subProtocol` in interface `WebSocketBase`
      Returns:

    - #### closeStatusCode

          public Short closeStatusCode()

      Returns the close status code received from the remote endpoint or `null` when not yet received.
      Specified by:
        `closeStatusCode` in interface `WebSocketBase`
      Returns:

    - #### closeReason

          public String closeReason()

      Returns the close reason message from the remote endpoint or `null` when not yet received.
      Specified by:
        `closeReason` in interface `WebSocketBase`
      Returns:

    - #### headers

          public MultiMap headers()

      Returns the HTTP headers when the WebSocket is first obtained in the handler.

      The headers will be `null` on subsequent interactions.
      Specified by:
        `headers` in interface `WebSocketBase`
      Returns:
        the headers

    - #### writePing

          public WebSocketBase writePing(Buffer data,
                                         Handler<AsyncResult<Void>> handler)

      Writes a ping frame to the connection. This will be written in a single frame. Ping frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 Section section 5.5.2.

      There is no handler for ping frames because RFC 6455 clearly states that the only response to a ping frame is a pong frame with identical contents.

      Specified by:
        `writePing` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
        `handler` - called when the ping frame has been successfully written
      Returns:
        a reference to this, so the API can be used fluently

    - #### writePing

          public WebSocketBase writePing(Buffer data)

      Writes a ping frame to the connection. This will be written in a single frame. Ping frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 Section section 5.5.2.

      There is no handler for ping frames because RFC 6455 clearly states that the only response to a ping frame is a pong frame with identical contents.

      Specified by:
        `writePing` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a reference to this, so the API can be used fluently

    - #### rxWritePing

          public Completable rxWritePing(Buffer data)

      Writes a ping frame to the connection. This will be written in a single frame. Ping frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 Section section 5.5.2.

      There is no handler for ping frames because RFC 6455 clearly states that the only response to a ping frame is a pong frame with identical contents.

      Specified by:
        `rxWritePing` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a reference to this, so the API can be used fluently

    - #### writePong

          public WebSocketBase writePong(Buffer data,
                                         Handler<AsyncResult<Void>> handler)

      Writes a pong frame to the connection. This will be written in a single frame. Pong frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 section 5.5.2.

      There is no need to manually write a pong frame, as the server and client both handle responding to a ping from with a pong from automatically and this is exposed to users. RFC 6455 section 5.5.3 states that pongs may be sent unsolicited in order to implement a one way heartbeat.

      Specified by:
        `writePong` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
        `handler` - called when the pong frame has been successfully written
      Returns:
        a reference to this, so the API can be used fluently

    - #### writePong

          public WebSocketBase writePong(Buffer data)

      Writes a pong frame to the connection. This will be written in a single frame. Pong frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 section 5.5.2.

      There is no need to manually write a pong frame, as the server and client both handle responding to a ping from with a pong from automatically and this is exposed to users. RFC 6455 section 5.5.3 states that pongs may be sent unsolicited in order to implement a one way heartbeat.

      Specified by:
        `writePong` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a reference to this, so the API can be used fluently

    - #### rxWritePong

          public Completable rxWritePong(Buffer data)

      Writes a pong frame to the connection. This will be written in a single frame. Pong frames may be at most 125 bytes (octets).

      This method should not be used to write application data and should only be used for implementing a keep alive or to ensure the client is still responsive, see RFC 6455 section 5.5.2.

      There is no need to manually write a pong frame, as the server and client both handle responding to a ping from with a pong from automatically and this is exposed to users. RFC 6455 section 5.5.3 states that pongs may be sent unsolicited in order to implement a one way heartbeat.

      Specified by:
        `rxWritePong` in interface `WebSocketBase`
      Parameters:
        `data` - the data to write, may be at most 125 bytes
      Returns:
        a reference to this, so the API can be used fluently

    - #### textMessageHandler

          public WebSocketBase textMessageHandler(Handler<String> handler)

      Set a text message handler on the connection. This handler will be called similar to the , but the buffer will be converted to a String first
      Specified by:
        `textMessageHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### binaryMessageHandler

          public WebSocketBase binaryMessageHandler(Handler<Buffer> handler)

      Set a binary message handler on the connection. This handler serves a similar purpose to `handler(io.vertx.core.Handler<io.vertx.reactivex.core.buffer.Buffer>)` except that if a message comes into the socket in multiple frames, the data from the frames will be aggregated into a single buffer before calling the handler (using `WebSocketFrame.isFinal()` to find the boundaries).
      Specified by:
        `binaryMessageHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### pongHandler

          public WebSocketBase pongHandler(Handler<Buffer> handler)

      Set a pong frame handler on the connection. This handler will be invoked every time a pong frame is received on the server, and can be used by both clients and servers since the RFC 6455 section 5.5.2 and section 5.5.3 do not specify whether the client or server sends a ping.

      Pong frames may be at most 125 bytes (octets).

      There is no ping handler since ping frames should immediately be responded to with a pong frame with identical content

      Pong frames may be received unsolicited.

      Specified by:
        `pongHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### end

          public void end(Handler<AsyncResult<Void>> handler)

      Calls `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)`
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` -

    - #### end

          public void end()

      Calls `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)`
      Specified by:
        `end` in interface `WebSocketBase`
      Specified by:
        `end` in interface `WriteStream<Buffer>`

    - #### rxEnd

          public Completable rxEnd()

      Calls `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)`
      Specified by:
        `rxEnd` in interface `WebSocketBase`
      Specified by:
        `rxEnd` in interface `WriteStream<Buffer>`
      Returns:

    - #### close

          public void close(Handler<AsyncResult<Void>> handler)

      Same as `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `close` in interface `WebSocketBase`
      Parameters:
        `handler` -

    - #### close

          public void close()

      Same as `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `close` in interface `WebSocketBase`

    - #### rxClose

          public Completable rxClose()

      Same as `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `rxClose` in interface `WebSocketBase`
      Returns:

    - #### close

          public void close(short statusCode,
                            Handler<AsyncResult<Void>> handler)

      Same as `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `close` in interface `WebSocketBase`
      Parameters:
        `statusCode` -
        `handler` -

    - #### close

          public void close(short statusCode)

      Same as `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `close` in interface `WebSocketBase`
      Parameters:
        `statusCode` -

    - #### rxClose

          public Completable rxClose(short statusCode)

      Same as `WebSocketBase.close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `rxClose` in interface `WebSocketBase`
      Parameters:
        `statusCode` -
      Returns:

    - #### close

          public void close(short statusCode,
                            String reason,
                            Handler<AsyncResult<Void>> handler)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `close` in interface `WebSocketBase`
      Parameters:
        `statusCode` -
        `reason` -
        `handler` -

    - #### close

          public void close(short statusCode,
                            String reason)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `close` in interface `WebSocketBase`
      Parameters:
        `statusCode` -
        `reason` -

    - #### rxClose

          public Completable rxClose(short statusCode,
                                     String reason)

      Same as but with an `handler` called when the operation completes
      Specified by:
        `rxClose` in interface `WebSocketBase`
      Parameters:
        `statusCode` -
        `reason` -
      Returns:

    - #### remoteAddress

          public SocketAddress remoteAddress()

      Specified by:
        `remoteAddress` in interface `WebSocketBase`
      Returns:
        the remote address for this connection, possibly `null` (e.g a server bound on a domain socket). If `useProxyProtocol` is set to `true`, the address returned will be of the actual connecting client.

    - #### localAddress

          public SocketAddress localAddress()

      Specified by:
        `localAddress` in interface `WebSocketBase`
      Returns:
        the local address for this connection, possibly `null` (e.g a server bound on a domain socket) If `useProxyProtocol` is set to `true`, the address returned will be of the proxy.

    - #### isSsl

          public boolean isSsl()

      Specified by:
        `isSsl` in interface `WebSocketBase`
      Returns:
        true if this `HttpConnection` is encrypted via SSL/TLS.

    - #### isClosed

          public boolean isClosed()

      Specified by:
        `isClosed` in interface `WebSocketBase`
      Returns:
        `true` if the WebSocket is closed

    - #### exceptionHandler

          public ServerWebSocket exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `ReadStream`
      Set an exception handler on the read stream.
      Specified by:
        `exceptionHandler` in interface `WebSocketBase`
      Specified by:
        `exceptionHandler` in interface `ReadStream<Buffer>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### handler

          public ServerWebSocket handler(Handler<Buffer> handler)

      Description copied from interface: `ReadStream`
      Set a data handler. As data is read, the handler will be called with the data.
      Specified by:
        `handler` in interface `WebSocketBase`
      Specified by:
        `handler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### pause

          public ServerWebSocket pause()

      Description copied from interface: `ReadStream`
      Pause the `ReadStream`, it sets the buffer in `fetch` mode and clears the actual demand.

      While it's paused, no data will be sent to the data `handler`.

      Specified by:
        `pause` in interface `WebSocketBase`
      Specified by:
        `pause` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### resume

          public ServerWebSocket resume()

      Description copied from interface: `ReadStream`
      Resume reading, and sets the buffer in `flowing` mode.

      If the `ReadStream` has been paused, reading will recommence on it.
      Specified by:
        `resume` in interface `WebSocketBase`
      Specified by:
        `resume` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### fetch

          public ServerWebSocket fetch(long amount)

      Description copied from interface: `ReadStream`
      Fetch the specified `amount` of elements. If the `ReadStream` has been paused, reading will recommence with the specified `amount` of items, otherwise the specified `amount` will be added to the current stream demand.
      Specified by:
        `fetch` in interface `WebSocketBase`
      Specified by:
        `fetch` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### endHandler

          public ServerWebSocket endHandler(Handler<Void> endHandler)

      Description copied from interface: `ReadStream`
      Set an end handler. Once the stream has ended, and there is no more data to be read, this handler will be called.
      Specified by:
        `endHandler` in interface `WebSocketBase`
      Specified by:
        `endHandler` in interface `ReadStream<Buffer>`
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public ServerWebSocket setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WebSocketBase`
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Buffer>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public ServerWebSocket drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WebSocketBase`
      Specified by:
        `drainHandler` in interface `WriteStream<Buffer>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeFrame

          public ServerWebSocket writeFrame(WebSocketFrame frame,
                                            Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFrame(io.vertx.reactivex.core.http.WebSocketFrame, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeFrame` in interface `WebSocketBase`
      Returns:

    - #### writeFrame

          public ServerWebSocket writeFrame(WebSocketFrame frame)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFrame(io.vertx.reactivex.core.http.WebSocketFrame, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeFrame` in interface `WebSocketBase`
      Returns:

    - #### rxWriteFrame

          public Completable rxWriteFrame(WebSocketFrame frame)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFrame(io.vertx.reactivex.core.http.WebSocketFrame, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `rxWriteFrame` in interface `WebSocketBase`
      Returns:

    - #### writeFinalTextFrame

          public ServerWebSocket writeFinalTextFrame(String text,
                                                     Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalTextFrame(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeFinalTextFrame` in interface `WebSocketBase`
      Returns:

    - #### writeFinalTextFrame

          public ServerWebSocket writeFinalTextFrame(String text)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalTextFrame(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeFinalTextFrame` in interface `WebSocketBase`
      Returns:

    - #### rxWriteFinalTextFrame

          public Completable rxWriteFinalTextFrame(String text)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalTextFrame(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `rxWriteFinalTextFrame` in interface `WebSocketBase`
      Returns:

    - #### writeFinalBinaryFrame

          public ServerWebSocket writeFinalBinaryFrame(Buffer data,
                                                       Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalBinaryFrame(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeFinalBinaryFrame` in interface `WebSocketBase`
      Returns:

    - #### writeFinalBinaryFrame

          public ServerWebSocket writeFinalBinaryFrame(Buffer data)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalBinaryFrame(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeFinalBinaryFrame` in interface `WebSocketBase`
      Returns:

    - #### rxWriteFinalBinaryFrame

          public Completable rxWriteFinalBinaryFrame(Buffer data)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeFinalBinaryFrame(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `rxWriteFinalBinaryFrame` in interface `WebSocketBase`
      Returns:

    - #### writeBinaryMessage

          public ServerWebSocket writeBinaryMessage(Buffer data,
                                                    Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeBinaryMessage(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeBinaryMessage` in interface `WebSocketBase`
      Returns:

    - #### writeBinaryMessage

          public ServerWebSocket writeBinaryMessage(Buffer data)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeBinaryMessage(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeBinaryMessage` in interface `WebSocketBase`
      Returns:

    - #### rxWriteBinaryMessage

          public Completable rxWriteBinaryMessage(Buffer data)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeBinaryMessage(io.vertx.reactivex.core.buffer.Buffer, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `rxWriteBinaryMessage` in interface `WebSocketBase`
      Returns:

    - #### writeTextMessage

          public ServerWebSocket writeTextMessage(String text,
                                                  Handler<AsyncResult<Void>> handler)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeTextMessage(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeTextMessage` in interface `WebSocketBase`
      Returns:

    - #### writeTextMessage

          public ServerWebSocket writeTextMessage(String text)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeTextMessage(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `writeTextMessage` in interface `WebSocketBase`
      Returns:

    - #### rxWriteTextMessage

          public Completable rxWriteTextMessage(String text)

      Description copied from interface: `WebSocketBase`
      Same as `WebSocketBase.writeTextMessage(java.lang.String, io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` but with an `handler` called when the operation completes
      Specified by:
        `rxWriteTextMessage` in interface `WebSocketBase`
      Returns:

    - #### closeHandler

          public ServerWebSocket closeHandler(Handler<Void> handler)

      Description copied from interface: `WebSocketBase`
      Set a close handler. This will be called when the WebSocket is closed.

      After this callback, no more messages are expected. When the WebSocket received a close frame, the `WebSocketBase.closeStatusCode()` will return the status code and `WebSocketBase.closeReason()` will return the reason.
      Specified by:
        `closeHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### frameHandler

          public ServerWebSocket frameHandler(Handler<WebSocketFrame> handler)

      Description copied from interface: `WebSocketBase`
      Set a frame handler on the connection. This handler will be called when frames are read on the connection.
      Specified by:
        `frameHandler` in interface `WebSocketBase`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### scheme

          public String scheme()

      Returns:
        the WebSocket handshake scheme

    - #### host

          public String host()

      Returns:
        the WebSocket handshake host

    - #### uri

          public String uri()

    - #### path

          public String path()

      Returns:
        the WebSocket handshake path.

    - #### query

          public String query()

      Returns:
        the WebSocket handshake query string.

    - #### accept

          public void accept()

      Accept the WebSocket and terminate the WebSocket handshake.

      This method should be called from the WebSocket handler to explicitly accept the WebSocket and terminate the WebSocket handshake.

    - #### reject

          public void reject()

      Reject the WebSocket.

      Calling this method from the WebSocket handler when it is first passed to you gives you the opportunity to reject the WebSocket, which will cause the WebSocket handshake to fail by returning a response code.

      You might use this method, if for example you only want to accept WebSockets with a particular path.

    - #### reject

          public void reject(int status)

      Like `reject()` but with a `status`.
      Parameters:
        `status` -

    - #### setHandshake

          public void setHandshake(Future<Integer> future,
                                   Handler<AsyncResult<Integer>> handler)

      Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be
      - accepted when the `future` succeeds with the HTTP status code
      - rejected when the `future` is succeeds with an HTTP status code different than
      - rejected when the `future` fails with the HTTP status code `500`
      The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward. Thus it is advised to try to complete the `future` with or .

      This method should be called from the WebSocket handler to explicitly set an asynchronous handshake.

      Calling this method will override the `future` completion handler.

      Parameters:
        `future` - the future to complete with
        `handler` - the completion handler

    - #### setHandshake

          public void setHandshake(Future<Integer> future)

      Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be
      - accepted when the `future` succeeds with the HTTP status code
      - rejected when the `future` is succeeds with an HTTP status code different than
      - rejected when the `future` fails with the HTTP status code `500`
      The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward. Thus it is advised to try to complete the `future` with or .

      This method should be called from the WebSocket handler to explicitly set an asynchronous handshake.

      Calling this method will override the `future` completion handler.

      Parameters:
        `future` - the future to complete with

    - #### rxSetHandshake

          public Single<Integer> rxSetHandshake(Future<Integer> future)

      Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be
      - accepted when the `future` succeeds with the HTTP status code
      - rejected when the `future` is succeeds with an HTTP status code different than
      - rejected when the `future` fails with the HTTP status code `500`
      The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward. Thus it is advised to try to complete the `future` with or .

      This method should be called from the WebSocket handler to explicitly set an asynchronous handshake.

      Calling this method will override the `future` completion handler.

      Parameters:
        `future` - the future to complete with
      Returns:

    - #### setHandshake

          public void setHandshake(Single<Integer> future,
                                   Handler<AsyncResult<Integer>> handler)

      Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be
      - accepted when the `future` succeeds with the HTTP status code
      - rejected when the `future` is succeeds with an HTTP status code different than
      - rejected when the `future` fails with the HTTP status code `500`
      The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward. Thus it is advised to try to complete the `future` with or .

      This method should be called from the WebSocket handler to explicitly set an asynchronous handshake.

      Calling this method will override the `future` completion handler.

      Parameters:
        `future` - the future to complete with
        `handler` - the completion handler

    - #### setHandshake

          public void setHandshake(Single<Integer> future)

      Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be
      - accepted when the `future` succeeds with the HTTP status code
      - rejected when the `future` is succeeds with an HTTP status code different than
      - rejected when the `future` fails with the HTTP status code `500`
      The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward. Thus it is advised to try to complete the `future` with or .

      This method should be called from the WebSocket handler to explicitly set an asynchronous handshake.

      Calling this method will override the `future` completion handler.

      Parameters:
        `future` - the future to complete with

    - #### rxSetHandshake

          public Single<Integer> rxSetHandshake(Single<Integer> future)

      Set an asynchronous result for the handshake, upon completion of the specified `future`, the WebSocket will either be
      - accepted when the `future` succeeds with the HTTP status code
      - rejected when the `future` is succeeds with an HTTP status code different than
      - rejected when the `future` fails with the HTTP status code `500`
      The provided future might be completed by the WebSocket itself, e.g calling the `close(io.vertx.core.Handler<io.vertx.core.AsyncResult<java.lang.Void>>)` method will try to accept the handshake and close the WebSocket afterward. Thus it is advised to try to complete the `future` with or .

      This method should be called from the WebSocket handler to explicitly set an asynchronous handshake.

      Calling this method will override the `future` completion handler.

      Parameters:
        `future` - the future to complete with
      Returns:

    - #### sslSession

          public SSLSession sslSession()

      Returns:
        SSLSession associated with the underlying socket. Returns null if connection is not SSL.

    - #### newInstance

          public static ServerWebSocket newInstance(ServerWebSocket arg)

Copyright © 2021 Eclipse. All rights reserved.